/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.70 by edhill, Sat Feb 28 05:01:12 2004 UTC revision 1.73 by edhill, Tue Mar 16 18:20:34 2004 UTC
# Line 37  test_for_string_in_file() { Line 37  test_for_string_in_file() {
37      grep -i "$strng" $file > /dev/null 2>&1      grep -i "$strng" $file > /dev/null 2>&1
38      RETVAL=$?      RETVAL=$?
39      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
40          echo -n "Error: In $file there is an illegal line: "          printf "Error: In $file there is an illegal line: "
41          grep -i "$strng" $file          grep -i "$strng" $file
42          return 1          return 1
43      fi      fi
# Line 80  find_possible_configs()  { Line 80  find_possible_configs()  {
80      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
81      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
82      tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
83      PLATFORM=$tmp2      tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
84        PLATFORM=$tmp3
85      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
86      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
87            
# Line 119  find_possible_configs()  { Line 120  find_possible_configs()  {
120      #    4) fall back to the buggy local xmakedpend script      #    4) fall back to the buggy local xmakedpend script
121      #      #
122      if test "x${MAKEDEPEND}" = x ; then      if test "x${MAKEDEPEND}" = x ; then
123        which makedepend >& /dev/null        which makedepend > /dev/null 2>&1
124        RETVAL=$?        RETVAL=$?
125        if test ! "x${RETVAL}" = x0 ; then        if test ! "x${RETVAL}" = x0 ; then
126           echo "    a system-default makedepend was not found."           echo "    a system-default makedepend was not found."
# Line 258  get_pdepend_list()  { Line 259  get_pdepend_list()  {
259      . ./.pd_tmp      . ./.pd_tmp
260      rm -f ./.pd_tmp      rm -f ./.pd_tmp
261    
262      echo -n "PNAME = "${}      printf "PNAME = "${}
263  }  }
264    
265    
# Line 348  Usage: "$0" [OPTIONS] Line 349  Usage: "$0" [OPTIONS]
349            set to PATH. i.e. Include files from $PATH/include, link to libraries            set to PATH. i.e. Include files from $PATH/include, link to libraries
350            from $PATH/lib and use binaries from $PATH/bin.            from $PATH/lib and use binaries from $PATH/bin.
351    
352        -bash NAME
353              Explicitly specify the Bourne or BASH shell to use
354    
355    While it is most often a single word, the "NAME" variables specified    While it is most often a single word, the "NAME" variables specified
356    above can in many cases be a space-delimited string such as:    above can in many cases be a space-delimited string such as:
357    
# Line 582  SOURCEDIRS= Line 586  SOURCEDIRS=
586  INCLUDEDIRS=  INCLUDEDIRS=
587  STANDARDDIRS="USE_THE_DEFAULT"  STANDARDDIRS="USE_THE_DEFAULT"
588    
589    G2ARGS=
590    BASH=
591  PWD=`pwd`  PWD=`pwd`
592  MAKE=make  MAKE=make
593  AWK=awk  AWK=awk
# Line 650  for i in . $MODS ; do Line 656  for i in . $MODS ; do
656          break          break
657      fi      fi
658  done  done
659  echo -n "  getting local config information:  "  printf "  getting local config information:  "
660  if test -e $gm_local ; then  if test -e $gm_local ; then
661      echo "using $gm_local"      echo "using $gm_local"
662      . $gm_local      . $gm_local
# Line 674  fi Line 680  fi
680  ac_prev=  ac_prev=
681  for ac_option ; do  for ac_option ; do
682    
683        G2ARGS="$G2ARGS \"$ac_option\""
684    
685      # If the previous option needs an argument, assign it.      # If the previous option needs an argument, assign it.
686      if test -n "$ac_prev"; then      if test -n "$ac_prev"; then
687          eval "$ac_prev=\$ac_option"          eval "$ac_prev=\$ac_option"
# Line 715  for ac_option ; do Line 723  for ac_option ; do
723          -make=* | --make=* | -m=* | --m=*)          -make=* | --make=* | -m=* | --m=*)
724              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
725                    
726            -bash | --bash)
727                ac_prev=BASH ;;
728            -bash=* | --bash=*)
729                BASH=$ac_optarg ;;
730            
731          -makedepend | --makedepend | -md | --md)          -makedepend | --makedepend | -md | --md)
732              ac_prev=MAKEDEPEND ;;              ac_prev=MAKEDEPEND ;;
733          -makedepend=* | --makedepend=* | -md=* | --md=*)          -makedepend=* | --makedepend=* | -md=* | --md=*)
# Line 829  if test "x${ROOTDIR}" = x ; then Line 842  if test "x${ROOTDIR}" = x ; then
842          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
843              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
844                  ROOTDIR=$d                  ROOTDIR=$d
845                  echo -n "Warning:  ROOTDIR was not specified but there appears to be"                  printf "Warning:  ROOTDIR was not specified but there appears to be"
846                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
847                  break                  break
848              fi              fi
# Line 863  if test "x$OPTFILE" != xNONE ; then Line 876  if test "x$OPTFILE" != xNONE ; then
876          . "$OPTFILE"          . "$OPTFILE"
877          RETVAL=$?          RETVAL=$?
878          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
879              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""              printf "Error: failed to source OPTFILE \"$OPTFILE\""
880              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
881              exit 1              exit 1
882          fi          fi
# Line 890  if test "x${AD_OPTFILE}" != xNONE ; then Line 903  if test "x${AD_OPTFILE}" != xNONE ; then
903          . "$AD_OPTFILE"          . "$AD_OPTFILE"
904          RETVAL=$?          RETVAL=$?
905          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
906              echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""              printf "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
907              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
908              exit 1              exit 1
909          fi          fi
# Line 905  fi Line 918  fi
918    
919  #  Check that FC, LINK, CPP, S64, LN, and MAKE are defined.  If not,  #  Check that FC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
920  #  either set defaults or complain and abort!  #  either set defaults or complain and abort!
921    if test ! "x$BASH" = x ; then
922        # add a trailing space so that it works within the Makefile syntax (see below)
923        BASH="$BASH "
924    fi
925  if test "x$FC" = x ; then  if test "x$FC" = x ; then
926      cat <<EOF 1>&2      cat <<EOF 1>&2
927    
# Line 975  if test ! "x$MPI" = x ; then Line 992  if test ! "x$MPI" = x ; then
992  fi  fi
993    
994  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
995  echo -n "  Do we have the system() command using $FC...  "  printf "  Do we have the system() command using $FC...  "
996  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.f <<EOF
997        program hello        program hello
998        call system('echo hi')        call system('echo hi')
# Line 993  else Line 1010  else
1010  fi  fi
1011  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1012    
1013  echo -n "  Do we have the fdate() command using $FC...  "  printf "  Do we have the fdate() command using $FC...  "
1014  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.f <<EOF
1015        program hello        program hello
1016        CHARACTER(128) string        CHARACTER(128) string
# Line 1014  else Line 1031  else
1031  fi  fi
1032  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1033    
1034  echo -n "  Can we call simple C routines (here, \"cloc()\") using $FC...  "  printf "  Can we call simple C routines (here, \"cloc()\") using $FC...  "
1035  check_HAVE_CLOC  check_HAVE_CLOC
1036  if test "x$HAVE_CLOC" != x ; then  if test "x$HAVE_CLOC" != x ; then
1037      echo "yes"      echo "yes"
# Line 1023  else Line 1040  else
1040  fi  fi
1041  rm -f genmake_t*  rm -f genmake_t*
1042    
1043  echo -n "  Can we create NetCDF-enabled binaries...  "  printf "  Can we create NetCDF-enabled binaries...  "
1044  check_netcdf_libs  check_netcdf_libs
1045  if test "x$HAVE_NETCDF" != x ; then  if test "x$HAVE_NETCDF" != x ; then
1046      echo "yes"      echo "yes"
# Line 1033  fi Line 1050  fi
1050    
1051    
1052  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1053  echo -n "  Adding MODS directories:  "  printf "  Adding MODS directories:  "
1054  for d in $MODS ; do  for d in $MODS ; do
1055      if test ! -d $d ; then      if test ! -d $d ; then
1056          echo          echo
1057          echo "Error: MODS directory \"$d\" not found!"          echo "Error: MODS directory \"$d\" not found!"
1058          exit 1          exit 1
1059      else      else
1060          echo -n " $d"          printf " $d"
1061          SOURCEDIRS="$SOURCEDIRS $d"          SOURCEDIRS="$SOURCEDIRS $d"
1062          INCLUDEDIRS="$INCLUDEDIRS $d"          INCLUDEDIRS="$INCLUDEDIRS $d"
1063      fi      fi
# Line 1165  else Line 1182  else
1182          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1183          RETVAL=$?          RETVAL=$?
1184          if test "x${RETVAL}" != x0 ; then          if test "x${RETVAL}" != x0 ; then
1185              echo -n "Error: can't parse default package list "              printf "Error: can't parse default package list "
1186              echo "-- please check PDEFAULT=\"$PDEFAULT\""              echo "-- please check PDEFAULT=\"$PDEFAULT\""
1187              exit 1              exit 1
1188          fi          fi
# Line 1448  rm -rf .links.tmp Line 1465  rm -rf .links.tmp
1465  mkdir .links.tmp  mkdir .links.tmp
1466  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
1467  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
1468  echo -n 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
1469  echo -n 'CSRCFILES = '   > csrclist.inc  printf 'CSRCFILES = '   > csrclist.inc
1470  echo -n 'F90SRCFILES = ' > f90srclist.inc  printf 'F90SRCFILES = ' > f90srclist.inc
1471  echo -n 'HEADERFILES = ' > hlist.inc  printf 'HEADERFILES = ' > hlist.inc
1472  echo -n 'AD_FLOW_FILES = ' > ad_flow_files.inc  printf 'AD_FLOW_FILES = ' > ad_flow_files.inc
1473  alldirs="$SOURCEDIRS $INCLUDEDIRS ."  alldirs="$SOURCEDIRS $INCLUDEDIRS ."
1474  for d in $alldirs ; do  for d in $alldirs ; do
1475      deplist=      deplist=
# Line 1477  for d in $alldirs ; do Line 1494  for d in $alldirs ; do
1494                  case $extn in                  case $extn in
1495                      F)                      F)
1496                          echo    " \\"  >> srclist.inc                          echo    " \\"  >> srclist.inc
1497                          echo -n " $sf" >> srclist.inc                          printf " $sf" >> srclist.inc
1498                          ;;                          ;;
1499                      F90)                      F90)
1500                          echo    " \\"  >> f90srclist.inc                          echo    " \\"  >> f90srclist.inc
1501                          echo -n " $sf" >> f90srclist.inc                          printf " $sf" >> f90srclist.inc
1502                          ;;                          ;;
1503                      c)                      c)
1504                          echo    " \\"  >> csrclist.inc                          echo    " \\"  >> csrclist.inc
1505                          echo -n " $sf" >> csrclist.inc                          printf " $sf" >> csrclist.inc
1506                          ;;                          ;;
1507                      h)                      h)
1508                          echo    " \\"  >> hlist.inc                          echo    " \\"  >> hlist.inc
1509                          echo -n " $sf" >> hlist.inc                          printf " $sf" >> hlist.inc
1510                          ;;                          ;;
1511                      flow)                      flow)
1512                          echo    " \\"  >> ad_flow_files.inc                          echo    " \\"  >> ad_flow_files.inc
1513                          echo -n " $sf" >> ad_flow_files.inc                          printf " $sf" >> ad_flow_files.inc
1514                          ;;                          ;;
1515                  esac                  esac
1516              fi              fi
# Line 1522  echo "#    $MACHINE" >> $MAKEFILE Line 1539  echo "#    $MACHINE" >> $MAKEFILE
1539  echo "# This makefile was generated automatically on" >> $MAKEFILE  echo "# This makefile was generated automatically on" >> $MAKEFILE
1540  echo "#    $THISDATE" >> $MAKEFILE  echo "#    $THISDATE" >> $MAKEFILE
1541  echo "# by the command:" >> $MAKEFILE  echo "# by the command:" >> $MAKEFILE
1542  echo "#    $0 $@" >> $MAKEFILE  echo "#    $0 $G2ARGS" >> $MAKEFILE
1543  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
1544  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE
1545    
# Line 1643  depend: Line 1660  depend:
1660          @make links          @make links
1661          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1662          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
1663            -rm -f makedepend.out
1664    
1665  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
1666    
# Line 1668  CLEAN: Line 1686  CLEAN:
1686    
1687  #eh3 Makefile: makefile  #eh3 Makefile: makefile
1688  makefile:  makefile:
1689          $THIS_SCRIPT $@          $THIS_SCRIPT $G2ARGS
1690  cleanlinks:  cleanlinks:
1691          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
1692    
1693  # Special targets ($SPECIAL_FILES) which are create by make  # Special targets ($SPECIAL_FILES) which are create by make
1694  ${PACKAGES_DOT_H}:  ${PACKAGES_DOT_H}:
1695          @echo Creating \$@ ...          @echo Creating \$@ ...
1696          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
1697  AD_CONFIG.h:  AD_CONFIG.h:
1698          @echo Creating \$@ ...          @echo Creating \$@ ...
1699          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
1700  FC_NAMEMANGLE.h:  FC_NAMEMANGLE.h:
1701          @echo Creating \$@ ...          @echo Creating \$@ ...
1702          echo "$FC_NAMEMANGLE" > \$@          echo "$FC_NAMEMANGLE" > \$@
# Line 1725  done Line 1743  done
1743    
1744  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
1745  echo >> $MAKEFILE  echo >> $MAKEFILE
1746  echo -n "AD_FILES = " >> $MAKEFILE  printf "AD_FILES = " >> $MAKEFILE
1747  AD_FILES=`cat ad_files`  AD_FILES=`cat ad_files`
1748  for i in $AD_FILES ; do  for i in $AD_FILES ; do
1749      echo    " \\" >> $MAKEFILE      echo    " \\" >> $MAKEFILE
1750      echo -n " $i" >> $MAKEFILE      printf " $i" >> $MAKEFILE
1751  done  done
1752  echo >> $MAKEFILE  echo >> $MAKEFILE
1753  rm -f ad_files  rm -f ad_files
# Line 1742  adtaf: ad_taf_output.f Line 1760  adtaf: ad_taf_output.f
1760  adtamc: ad_tamc_output.f  adtamc: ad_tamc_output.f
1761    
1762  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1763          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
1764          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
1765          -rm -f ad_config.template          -rm -f ad_config.template
1766          @make \$(F77FILES)          @make \$(F77FILES)
# Line 1774  ftltaf: ftl_taf_output.f Line 1792  ftltaf: ftl_taf_output.f
1792  ftltamc: ftl_tamc_output.f  ftltamc: ftl_tamc_output.f
1793    
1794  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1795          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
1796          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
1797          -rm -f ftl_config.template          -rm -f ftl_config.template
1798          @make \$(F77FILES)          @make \$(F77FILES)
# Line 1847  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 1865  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
1865  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
1866    
1867  # Create special header files  # Create special header files
1868  $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"  $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
1869  if test ! -f $PACKAGES_DOT_H ; then  if test ! -f $PACKAGES_DOT_H ; then
1870      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1871  else  else
# Line 1861  else Line 1879  else
1879      fi      fi
1880  fi  fi
1881  if test ! -f AD_CONFIG.h ; then  if test ! -f AD_CONFIG.h ; then
1882      $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h      $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
1883  fi  fi
1884    
1885    
1886  #  Write the "state" for future records  #  Write the "state" for future records
1887  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" != xf ; then
1888      echo -n "" > genmake_state      printf "" > genmake_state
1889      for i in $gm_state ; do      for i in $gm_state ; do
1890          t1="t2=\$$i"          t1="t2=\$$i"
1891          eval $t1          eval $t1

Legend:
Removed from v.1.70  
changed lines
  Added in v.1.73

  ViewVC Help
Powered by ViewVC 1.1.22